import greenfoot.*;

/**
 * PROJECT NAME: Viral Spiral<br>
 * AUTHOR: danpost<br>
 * CREATED: October 6, 2013<br>
 * UPDATED: October 7, 2013<br><br>
 * 
 * <u>DESCRIPTION</u><br>
 * The main function of this project is to display different patterns that can be
 * created by starting with one arm, pinned at one end and drawing its color on the other end.
 * More arms can be added by pinning them on the open end (drawing end) of the last arm, one 
 * after another.  Each arm will draw a different color and be given a random rotational speed
 * value.<br><br>
 * 
 * <u>CONTROLS</u><br>
 * Use the '1' through '8' keys at the top of your keyboard to change the number of arms to draw
 * with.<br>
 * Click on the screen to produce another pattern with the current number of arms (this can also
 * be achieved by again pressing the number key representing the number of arms to draw with).
 */

public class Pad extends World
{
    /**
     * The constructor creates a base world of 600x600 and adds the Pin object into it,
     * which, in turn, adds the Pin.Arm objects. The number of arms is determined by the
     * value of a static int field in the Pin class call 'armCount'.
     */
    public Pad()
    {
        super(600, 600, 1);
        addObject(new Pin(), 300, 300);
    }
    
    /**
     * The act method checks for mouse clicks and valid keystrokes, and act upon them.
     * All valid actions lead to a new world Pad object (constructs a new world).
     * Being the 'Pin.armCount' value is static, its value does not reset.
     */
    public void act()
    {
        if (Greenfoot.mouseClicked(null)) Greenfoot.setWorld(new Pad()); // create new pattern
        String key = Greenfoot.getKey();
        if (key == null) return; // exit method if no keystroke detected
        if ("012345678".indexOf(key) > 0) // only '1' through '8' allowed
        {
            Pin.armCount = "012345678".indexOf(key); // sets the value of the static field
            Greenfoot.setWorld(new Pad()); // create new pattern
        }
    }
}